(function folderpaneToolsInit() {
  var fptOldLoadStartFolder = loadStartFolder;

  function fptLoadStartFolder(initialUri) {
    var prefs = chuonthisInitPrefs("");

    if (!initialUri && prefs.getBoolPref("folderpane.overrideStartup")) {
      // get custom startup folder
      var folderpaneStartupFolder = GetMsgFolderFromUri(chuonthisGetPrefString(prefs, "folderpane.startupFolder"), true);
      if(folderpaneStartupFolder) {
        initialUri = folderpaneStartupFolder.URI;

        // ensure folder is visible
        var folderTree = document.getElementById("folderTree");
        if (window.gFolderTreeView)
          gFolderTreeView.selectFolder(folderpaneStartupFolder);
        else
          EnsureFolderIndex(folderTree.builderView, folderpaneStartupFolder);
      }
    }

    return fptOldLoadStartFolder(initialUri);
  }

  function fptSortedAccounts()
  {
      const Cc = Components.classes;
      const Ci = Components.interfaces;
      var acctMgr = Cc["@mozilla.org/messenger/account-manager;1"]
                       .getService(Ci.nsIMsgAccountManager);
      var accounts = [a for each
                      (a in fixIterator(acctMgr.accounts, Ci.nsIMsgAccount))];
      // Bug 41133 workaround
      accounts = accounts.filter(function fix(a) { return a.incomingServer; });

      // Don't show deferred pop accounts
      accounts = accounts.filter(function isNotDeferred(a) {
        var server = a.incomingServer;
        return !(server instanceof Ci.nsIPop3IncomingServer &&
                 server.deferredToAccount);
      });

      return accounts;
  }

  window.loadStartFolder = fptLoadStartFolder;
  if (window.gFolderTreeView)
    window.gFolderTreeView._sortedAccounts = fptSortedAccounts;
  
})();
